#ifndef OVMENU_2D_COLORSETTINGS_H
#define OVMENU_2D_COLORSETTINGS_H

#include <QObject>
#include <QWidget>
#include "colorrect2.h"
#include <QPushButton>
#include <QActionGroup>
#include <QScrollArea>
#include <QLabel>
#include <QComboBox>
#include "widgets/twodoverlaybuttons.h"

namespace plot {

class ovMenu_2d_colorSettings : public colorRect2
{
    Q_OBJECT
public:
    ovMenu_2d_colorSettings(TwoDOverlayButtons *overlay);
    void set2DPlot(plot::T2dPlot *pl);
    QIcon getColoredIcon(QColor color, int width = 100, int height = 70);
    
    QComboBox *CBLineSelector;
    QComboBox *CBLineColor;
    QComboBox *CBLineWidth;
    QComboBox *CBFont;
    
#ifdef _ADROID
    bool vertical = false;
    VerticalLabel *vLLineSelector;
    VerticalLabel *vLLineColor;
    VerticalLabel *vLLineWidth;
    VerticalLabel *vLFont;
    verticalQComboBox *vCBLineSelector;
    verticalQComboBox *vCBLineColor;
    verticalQComboBox *vCBLineWidth;
    verticalQComboBox *vCBFont;
#endif
    
public slots:
    void onCbLineWidth_changed(int n);
    void onCBLineColor_changed(int n);
    void fontChanged(int n);
    
private slots:
    void plotResized(QSize newSize);
    void plotSetVisible(bool visible);
    
    #ifdef _ADROID
    void eventSlot(QEvent *Event);
#endif
    
private:
    TwoDOverlayButtons *overlay;
    T2dPlot *parentPlot;
    
    QLabel *LLineSelector;
    QLabel *LLineColor;
    QLabel *LLineWidth;
    QLabel *LFont;
    QString style;
    QColor CurveQColours[7];
    
    QList<QLabel*> lineChangersListLabels;
    QList<QWidget*> lineChangersListComboBox;
};

}

#endif // OVMENU_2D_COLORSETTINGS_H
