#ifndef OVMENU_2D_FILTERSETTINGS_H
#define OVMENU_2D_FILTERSETTINGS_H

#include <QObject>
#include <QWidget>
#include "colorrect2.h"
#include <QPushButton>
#include <QActionGroup>
#include <QScrollArea>
#include <QLabel>
#include <QComboBox>
#include "widgets/twodoverlaybuttons.h"

namespace plot {

class ovMenu_2d_filterSettings : public colorRect2
{
    Q_OBJECT
public:
    explicit ovMenu_2d_filterSettings(TwoDOverlayButtons *overlay);
    void set2DPlot(plot::T2dPlot *pl);
    
public: signals:
    void changedFilterSettings(int);
    
public slots:
#ifndef _ADROID
    void saveScan2DFilterSettings();
    void applyFilter2DSettings();
    void filterSettingsClicked();
#endif
    
private slots:
    void plotResized(QSize newSize);
    void plotSetVisible(bool visible);
    void onBackClicked();
    
private:
    TwoDOverlayButtons *overlay;
    T2dPlot *parentPlot;
    
    QString fontFamily;
#ifndef _ADROID
    //--------------2d filtger
    QList<QLabel*> filterSettingsLabels;
    QList<QWidget*> filterSettingsRightPart;
    
    bool showingfilterSettings = false;
#endif
    
#ifndef _ADROID
    QComboBox *cb2DFilter;
#endif
};

}

#endif // OVMENU_2D_FILTERSETTINGS_H
