#ifndef OVMENU_3D_FILTERSETTINGS_H
#define OVMENU_3D_FILTERSETTINGS_H

#include <QObject>
#include <QPushButton>
#include <QLabel>
#include <QComboBox>
#include <QDoubleSpinBox>
#include <QActionGroup>
#include "core/plot_core.h"
#include "colorrect2.h"
#include <QCheckBox>
#include <QScrollArea>
#include "plot_colorchooser.h"
#include "../../src/gui/edit.hpp"
#include <QGraphicsOpacityEffect>
#include <QPropertyAnimation>
#include <QLayout>
#include "threedoverlaybuttons.h"

namespace plot {

class ovMenu_3d_FilterSettings : public colorRect2
{
    Q_OBJECT
public:
    ovMenu_3d_FilterSettings(ThreeDOverlayButtons *overlay);
    
    void applyFilterSettings();
    void loadFilterSettings();
    
public slots:
    void saveScanFilterSettings();
    
private slots:
    void setVisiblePlot(bool visible, ThreeDOverlayButtons::SpecialVisibilityMode visibilityMode);
    void resized(QSize newSize);
    
private:
    ThreeDOverlayButtons *overlay;
    
    QList<QLabel*> filterSettingsLabels;
    QList<QWidget*> filterSettingsRightPart;
    
    QCheckBox *chFitLines;
    QCheckBox *chMeanValue;
    QCheckBox *chMedianValue;
    QCheckBox *chGaussian;
    QCheckBox *chHistogramEqualization;
    QComboBox *cbSubstract;
    QComboBox *cbFitting;
    QWidget *widMean;
    QWidget *widMedian;
    QWidget *widGaussian;
    Edit *edGaussian;
    Edit *edMeanValue;
    Edit *edMedianValue;
};

}

#endif // OVMENU_3D_FILTERSETTINGS_H
