#ifndef SCHACTIVEBOX_H
#define SCHACTIVEBOX_H

#include <QObject>
#include <QWidget>
#include <QLabel>
#include "scheme/abstractinoutlines.h"

class schActiveBox : public QWidget, public AbstractInOutLines
{
    Q_OBJECT
public:
    explicit schActiveBox(QWidget *parent = nullptr);
    void recalcPoints() override;
    
    QColor disabledColor = Qt::gray;
    QColor onColor = Qt::green;
    QColor offColor = Qt::red;
    bool isBoxEnabled = true;
    bool turnOn;
    QPixmap *pixmapImage = nullptr;
    
public slots:
    void setState(bool on);
    void setState_man(bool on);
    
signals:
    void changedState(bool st);
    
protected:
    bool event(QEvent *) override;
    void paintEvent(QPaintEvent *event) override;
    
private:
    inline void initPositions(int w, int h);
    bool hovered;
    QRect rect;
    QLabel *textLab;
};

#endif // SCHACTIVEBOX_H
