#ifndef SCHSAMPLECONTROLPLATFORM_H
#define SCHSAMPLECONTROLPLATFORM_H

#include <QObject>
#include <QWidget>
#include "scheme/abstractinoutlines.h"
#include <QLabel>

class schSampleControlPlatform : public QWidget, public AbstractInOutLines
{
    Q_OBJECT
public:
    schSampleControlPlatform(QWidget *parent);
    void recalcPoints() override;
    QColor sampleColor = Qt::gray;
    QColor tableColor = Qt::gray;
    QColor boxesColor = Qt::gray;
    QColor sampleClosingColor = Qt::green;
    int tubeWidth = 10;
    bool isSampleClosingToTable = false;
    
protected:
    bool event(QEvent *) override;
    void paintEvent(QPaintEvent *event) override;
    
private:
    inline void initPositions(int w, int h);
    
    QRect boxRect;
    QPolygon sample;
    QRect boxUp;
    QRect boxDown;
    QLabel *labelUp;
    QLabel *labelDown;
};

#endif // SCHSAMPLECONTROLPLATFORM_H
