#ifndef SCHTUBELOCKER_H
#define SCHTUBELOCKER_H

#include <QObject>
#include <QWidget>
#include "abstractinoutlines.h"
#include <QtEvents>
#include <QGestureEvent>
#include <QPainter>
#include <QDebug>
#include <QtGlobal>
#include <QTimer>
#include <QPolygon>
#include <QPaintEngine>

class schTubeLocker : public QWidget, public AbstractInOutLines
{
    Q_OBJECT
public:
    explicit schTubeLocker(QWidget *parent = nullptr);
    void recalcPoints() override;
    
    QColor onColor = Qt::red;
    QColor offColor = Qt::green;
    bool turnOn;
    int tubeWidth = 10;
    
public slots:
    void setState(bool on);
    void setState_man(bool on);
    
signals:
    void changedState(bool st);
    
protected:
    bool event(QEvent *) override;
    void paintEvent(QPaintEvent *event) override;
    
private:
    inline void initPositions(int w, int h);
    bool hovered;
    QPolygon polyTriangle[2];
    int centerY;
    int centerX;
    
public slots:
};

#endif // SCHTUBELOCKER_H
