#ifndef RECTSLSENSITIVITYADDITWINDOW_H
#define RECTSLSENSITIVITYADDITWINDOW_H

#include <QObject>
#include <QWidget>
#include <QLabel>
#include <QLayout>
#include <QComboBox>
#include <QPaintEngine>
#include <QtEvents>
#include <QtMath>
#include "controls.h"
#include "edit.hpp"
#include "rectslider.h"
#include "tools.hpp"

class rectSLSensitivityAdditWindow : public QWidget
{
    Q_OBJECT

public:
    rectSLSensitivityAdditWindow(RectSlider *parent);
    void addConnects(DoubleChanger *fbP, DoubleChanger *fbI, QComboBox *z);

    Edit *edFBP;
    Edit *edFBI;
    QComboBox *cbZ;

public: signals:
    void doubleClicked();

private:
    void initVariables();
    void initLayout();
    void paintEvent(QPaintEvent *event) override;
    bool eventFilter(QObject *Object, QEvent *Event) override;
    QLabel *labFBP;
    QLabel *labFBI;
    QLabel *labZ;

    RectSlider *parentSlider;

private slots:
    void setSielentComboBox(int index);
    void rectDblClicked();
};

#endif // RECTSLSENSITIVITYADDITWINDOW_H
