#ifndef EG3000_CALIBRATIONS_H
#define EG3000_CALIBRATIONS_H

#include "defs.h"
#include <QPair>

double analog_calib(double value, const char *name, double a0 = -10., double b0 = 10.);

double input_calib(BYTE ch, double val);
double input_gain(BYTE ch);
double input_shift(BYTE ch);
void input_gain_set(BYTE ch, double gain);
void input_gain_clear(BYTE ch);
void input_shift_set(BYTE ch, double shift);
void input_shift_clear(BYTE ch);

QPair<double, double> GetPairAnalogMapCache(int key);

QString input_units(BYTE ch);
void input_unit_set(BYTE ch, QString unit);
void input_unit_clear(BYTE ch);

void init_analog_calib_cache();

#endif // EG3000_CALIBRATIONS_H
