#ifndef CCDPLOTMODULE_H
#define CCDPLOTMODULE_H

#include "ccd/ccdplot.h"
#include "mobile/remote_mobile.hpp"
#include <QSettings>
#include "controls.h"
#include "mainwindow.h"
#include "modules.hpp"
#include "modules/ccdmatrixmodule.h"

class CCDPlotModule : public I_GUI_MODULE<CCDPlot>, public I_NET_MODULE_BASE
{
public:
    GUI_MODULE_CTOR(CCDPlotModule) {
        QSettings settings("Param/gui.conf", QSettings::IniFormat);
        AutoSend = settings.value("scan/autosend_data", true).toBool();
    }
    void *basecast(const QLatin1String name) { return name == QLatin1String("net") ? static_cast<I_NET_MODULE_BASE *>(this) : I_GUI_MODULE<CCDPlot>::basecast(name); }
    static const QLatin1String name() { return QLatin1String("ccdplot"); }
    static const QList<QLatin1String> requires() { return QList<QLatin1String>() << CCDMatrixModule::name(); }
    void connected(const QLatin1String name, I_MODULE *module) override;
    void setRunning(bool on) override { if (on) m_BStart->click(); }
    
    void initialSend(MobileInstance *client) override;
    void setValue(int id, QVariant val, QObject *sender) override;
    
    QPushButton *createPanelButton() override { return new QPushButton(makeHugeIcon(":/MainToolbar/ccd.png"), MainWindow::tr("Spectroscopy")); }
    QList<QWidget *> getStatusWidgets() override { return QList<QWidget *>() << getDeviceStatusList(); }
};

#endif // CCDPLOTMODULE_H
