#ifndef DATAMODULE_H
#define DATAMODULE_H

#include "dataplot.h"
#include "mobile/remote_mobile.hpp"
#include <QSettings>
#include "controls.h"
#include "mainwindow.h"
#include "modules.hpp"

class DataModule : public I_GUI_MODULE<DataPlot>, public I_NET_MODULE_BASE
{
public:
    GUI_MODULE_CTOR(DataModule) {
        QSettings settings("Param/gui.conf", QSettings::IniFormat);
        Container->SetAutoSaveTime(settings.value("autosave_time", 30).toInt() * 60 * 1000); //to msec
    }
    static const QLatin1String name() { return QLatin1String("data"); }
    void *basecast(const QLatin1String name) { return name == QLatin1String("net") ? static_cast<I_NET_MODULE_BASE *>(this) : I_GUI_MODULE<DataPlot>::basecast(name); }
    void setRunning(bool on) override { if (!on) Container->thread_close(); }
    
    //gui
    QPushButton *createPanelButton() { return new QPushButton(makeHugeIcon(":/MainToolbar/Data_plot.png"), MainWindow::tr("Data")); }
    
    //net
    void initialSend(MobileInstance *client) override;
    void setValue(int id, QVariant val, QObject *sender);
};

#endif // DATAMODULE_H
