#include "motorsmodule.h"

#include <QSettings>
#include "mainwindow.h"
#include "mobile/remote_mobile.hpp"
#include "gui/status.hpp"
#include "hardware/EG3000.h"
#include "modules/eg3000module.h"
#include "modules/optionsmodule.h"

void MotorsModule::connected(const QLatin1String name, I_MODULE *module)
{
    if (name == EG3000Module::name()) {
        EG3000_CONTROL *m = (EG3000_CONTROL *)module->basecast();
        
        m->rThread.readers.add(this);
        m->wThread.writers.add(this);
        
        connect(&m->rThread, SIGNAL(capBits(int,long)), this, SLOT(capBits(int,long)));
        
        connect(m, SIGNAL(usbStatus(int)), this, SLOT(usbStatusChanged(int)));
        connect(&m->rThread, SIGNAL(status(int)), this, SLOT(usbStatusChanged(int)));
    }
    if (name == OptionsModule::name()) {
        options *m = (options *)module->basecast();
        
        QSettings settings2("Param/gui.conf", QSettings::IniFormat);
        if (!settings2.value("gui/Ratis_xyz_stage_mode", false).toBool())
            m->addNewTab(mainw, QWidget::tr("MotorsAll2"), 2);
        else
            mainw->setVisible(false);
    }
}

void MotorsModule::setValue(int id, QVariant val, QObject *)
{
    if (id == DataID::Motor_123)
        //TODO landing motors?
        goShuttle(val.toInt(), 250);
    if (id == DataID::Motor_1)
        goShuttle(val.toInt(), mapPhysToVirt(1));
    if (id == DataID::Motor_2)
        goShuttle(val.toInt(), mapPhysToVirt(2));
    if (id == DataID::Motor_3)
        goShuttle(val.toInt(), mapPhysToVirt(3));
    if (id == DataID::Motor_4)
        goShuttle(val.toInt(), mapPhysToVirt(4));
}
