#ifndef MOTORSMODULE_H
#define MOTORSMODULE_H

#include "motors.hpp"
#include "modules.hpp"
#include "mobile/remote_mobile.hpp"
#include <QSettings>

class MotorsModule : public I_GUI_MODULE<Motors>, public I_NET_MODULE_BASE
{
public:
    GUI_MODULE_CTOR(MotorsModule) { }
    
    static const QLatin1String name() { return QLatin1String("motors"); }
    void connected(const QLatin1String name, I_MODULE *module) override;
    
    void *basecast(const QLatin1String name) override { return name == QLatin1String("net") ? static_cast<I_NET_MODULE_BASE *>(this) : I_GUI_MODULE<Motors>::basecast(name); }
    
    //gui
    QList<QWidget *> getStatusWidgets() override
    {
        QSettings settings2("Param/gui.conf", QSettings::IniFormat);
        if (settings2.value("gui/Ratis_xyz_stage_mode", false).toBool()) return QList<QWidget *>();
        return QList<QWidget *>() << (QWidget *)nullptr << SWmotorLabel << SWmotor1;
    }
    
    //net
    void setValue(int id, QVariant val, QObject *sender) override;
};

#endif // MOTORSMODULE_H
