#ifndef OPTIONSMODULE_H
#define OPTIONSMODULE_H

#include "modules.hpp"
#include "options/options.h"
#include "mobile/remote_mobile.hpp"
#include <QSettings>
#include "controls.h"
#include "mainwindow.h"

class OptionsModule : public I_GUI_MODULE<options>, public I_NET_MODULE_BASE
{
public:
    GUI_MODULE_CTOR(OptionsModule) { }
    
    static const QLatin1String name() { return QLatin1String("options"); }
    void connected(const QLatin1String name, I_MODULE *module) override;
    void *basecast(const QLatin1String name) override { return name == QLatin1String("net") ? static_cast<I_NET_MODULE_BASE *>(this) : I_GUI_MODULE<options>::basecast(name); }
    
    //gui
    QPushButton *createPanelButton() override
    {
        auto btn = new QPushButton(makeHugeIcon(":/MainToolbar/tools.png"), MainWindow::tr("Options"));
        QSettings settings2("Param/gui.conf", QSettings::IniFormat);
        if (settings2.value("gui/Ratis_xyz_stage_mode", false).toBool())
            btn->hide();
        return btn;
    }
};

#endif // OPTIONSMODULE_H
