#ifndef SCANMODULE_H
#define SCANMODULE_H

#include "scanplot.h"
#include "modules.hpp"
#include "mobile/remote_mobile.hpp"
#include "mainwindow.h"

class ScanModule : public I_GUI_MODULE<ScanPlot>, public I_NET_MODULE_BASE
{
public:
    GUI_MODULE_CTOR(ScanModule) {
        QSettings settings("Param/gui.conf", QSettings::IniFormat);
        Autosend = settings.value("scan/autosend_data", true).toBool();
    }
    static const QLatin1String name() { return QLatin1String("scan"); }
    void *basecast(const QLatin1String name) { return name == QLatin1String("net") ? static_cast<I_NET_MODULE_BASE *>(this) : I_GUI_MODULE<ScanPlot>::basecast(name); }
    void connected(const QLatin1String name, I_MODULE *module);
    
    //gui
    QPushButton *createPanelButton()
    {
        QSettings settings2("Param/gui.conf", QSettings::IniFormat);
        if (settings2.value("gui/Ratis_xyz_stage_mode", false).toBool()) return nullptr;
        return new QPushButton(makeHugeIcon(":/MainToolbar/Scan.png"), MainWindow::tr("Scan"));
    }
    
    //net
    void initialSend(MobileInstance *client) override;
    void setValue(int id, QVariant val, QObject *sender) override;
};

#endif // SCANMODULE_H
