#ifndef SPMMODULE_H
#define SPMMODULE_H

#include "spmtunning.h"
#include "modules.hpp"
#include "mobile/remote_mobile.hpp"
#include "gui/status.hpp"
#include "mainwindow.h"

class SPMModule : public I_GUI_MODULE<SPMTunning>, public I_NET_MODULE_BASE
{
public:
    GUI_MODULE_CTOR(SPMModule) {
        QSettings settings("Param/gui.conf", QSettings::IniFormat);
        AutoSend = settings.value("scan/autosend_data", true).toBool();
        isSPMHidded = !settings.value("display/spm", true).toBool();
    }
    static const QLatin1String name() { return QLatin1String("spm"); }
    void *basecast(const QLatin1String name) override { return name == QLatin1String("net") ? static_cast<I_NET_MODULE_BASE *>(this) : I_GUI_MODULE<SPMTunning>::basecast(name); }
    void connected(const QLatin1String name, I_MODULE *module) override;
    void setRunning(bool on) override;
    
    //gui
    QPushButton *createPanelButton() override
    {
        if (isSPMHidded) { this->setVisible(false); return nullptr;}
        return new QPushButton(makeHugeIcon(":/MainToolbar/Spm.png"), MainWindow::tr("SPM"));
    }
    QList<QWidget *> getStatusWidgets() override
    {
        QList<QWidget *> l;
        QSettings settings("Param/gui.conf", QSettings::IniFormat);
        if (isSPMHidded) return l;
        
        l << (QWidget *)nullptr << SWspmfb;
        if (settings.value("display/shuttle_status", true).toBool())
            l << (QWidget *)1 << shuttleStatus;
        return l;
    }
    
    //net
    void initialSend(MobileInstance *client) override;
    void setValue(int id, QVariant val, QObject *sender) override;
};

#endif // SPMMODULE_H
