#ifndef VIDEOMODULE_H
#define VIDEOMODULE_H

#include "USBVideo/videoplayer.h"
#include "modules.hpp"
#include "mobile/remote_mobile.hpp"

class VideoModule : public I_GUI_MODULE<VideoPlayer>, public I_NET_MODULE_BASE
{
public:
    GUI_MODULE_CTOR(VideoModule) { }
    static const QLatin1String name() { return QLatin1String("video"); }
    static const QList<QLatin1String> requires() { return QList<QLatin1String>() << QLatin1String("managedthreadedcleaner"); }
    void *basecast(const QLatin1String name) { return name == QLatin1String("net") ? static_cast<I_NET_MODULE_BASE *>(this) : I_GUI_MODULE<VideoPlayer>::basecast(name); }
    void connected(const QLatin1String name, I_MODULE *module) override;
    void setRunning(bool on) override { if (on) resetCameras(); }
    
    //gui
    //QPushButton *detachButton() { return PBToNewWindow; }
    //QPushButton *createPanelButton() { return new QPushButton(makeHugeIcon(":/SPMTuning_window/Video.png"), MainWindow::tr("Video") + (inst_idx == 0 ? QString() : " 2")); }
    QList<QWidget *> getStatusWidgets() override { return QList<QWidget *>() << (QWidget *)5 << deviceStatus; } //casting number 5 to... widget?
    
    //net
    void initialSend(MobileInstance *client) override {}
    void setValue(int id, QVariant val, QObject *sender) override;
};

#endif // VIDEOMODULE_H
