#ifndef RELAYOPTIONS_H
#define RELAYOPTIONS_H

#include <QObject>
#include <QWidget>
#include <QTableWidget>
#include <QLayout>
#include <QComboBox>
#include <QCheckBox>

enum StandartRelayRoles
{
    RR_None,
    RR_Controller,
};

class RelayOptions : public QWidget
{
    Q_OBJECT
    
public:
    RelayOptions(QWidget *parent = nullptr);
    static RelayOptions* GetIt() noexcept;
    void SetRelePower(bool on, int role);
    
    int numberRelay;
    
public slots:
    void enableAll();
    void disableAll();
    void enableController();
    void disableController();
    void enable(int role);
    void disable(int role);
    void updateReles();
    
protected:
    QWidget *mainWidget;
    
private slots:
    void relayPowerSwitched(bool on);
    void saveChanges();
    
private:
    int relayCount();
    void LoadRoles();
    void InitGUI();
    void InitReleTable(QVBoxLayout *lay);
    
    const int maxNumRele = 10;
    int currNumRele;
    
    QTableWidget *TableRele;
    QList<QComboBox *> cbRoles;
    QStringList strRoles;
    QList<QCheckBox *> cbPowerOn;
};

#endif // RELAYOPTIONS_H
