#ifndef PUMPSSTAGE_H
#define PUMPSSTAGE_H

#include <QObject>
#include <QWidget>
#include <QGroupBox>
#include <QRadioButton>
#include <QCheckBox>
#include "controls.h"
#include "motors.hpp"


class PumpsStage : public QGroupBox
{
    Q_OBJECT
public:
    PumpsStage();
    
    void setMotors(Motors *m);
    bool isMotorRolePumpStage(Motors::MotorRoles role);
    void startMotor(bool start, Motors::MotorRoles role, int distId);
    void setActiveMotor(Motors::MotorRoles role);
    
public slots:
    void startMoveStages(bool on);
    
private slots:
    void saveSettings();
    void motorEvent(int motor, bool atEnd, bool active);
    void start(bool);
    void confLineChangedSlot();
    
private:
    void initGUI();
    void loadSettings();
    
    QString title;
    
    TwoStateButton *startMotorBtn;
    QCheckBox *limitterCb;
    
    QTableWidget *tableConf;
    QRadioButton *radioSelectedConfLine[2];
    QLineEdit *textboxConfLine[2];
    Edit *confLinesValuesGui[2];
    
    Motors::MotorRoles currentMotorRole;
    
    //0 - x, 1 - y
    int currentMotorNum = 0;
    int xyStagePosition[2][2]; 
    bool xyStageLimit[2];
    int motorCurrentStages[2];
    int currentDistance[2];
};

#endif // PUMPSSTAGE_H
