#ifndef SINGLEAPP_H
#define SINGLEAPP_H

#include "modules.hpp"
#include <QSharedMemory>

#ifdef _START_AS_SECOND_PROGRAM_INSTANCE
    #define UNIQUE_KEY "nspec_multiapp_key"
#else
    #define UNIQUE_KEY "nspec_signleapp_key"
#endif

class SingleApp : public I_MODULE
{
public:
    SingleApp();
    ~SingleApp() override;
    bool setMessage(const QByteArray ba);
    QByteArray getMessage();
    
    static const QLatin1String name();
    void *basecast(const QLatin1String name) override;
    void setRunning(bool on) override;
    
    QSharedMemory singleapp_sharedmem;
    bool isSecondInstance;
    
    static SingleApp* GetIt() noexcept;
};

#endif // SINGLEAPP_H
