#pragma once

#include "defs.h"
#include <QWidget>
#include <QVBoxLayout>
#include <QGroupBox>
#include <QLabel>
class QCheckBox;
class QComboBox;
class Edit;

class TOptionsForMotor: public QWidget
{
    Q_OBJECT
public slots:
    void sl_update();
    void sl_save_to_file();
    void sl_load_from_file();

private:
    QCheckBox *CB_sysONMAF;
    Edit *LEdUpSpeed;
    Edit *LEdUpDist;
    Edit *LEdDistReady;
    Edit *LEdLandingSpeed;
    Edit *LEdLandingSpeedClose;
    Edit *LEdLandingSpeedCloseC;
    QCheckBox *CB_landing_up;
    Edit *LEdHeadLandingExitDist;
    Edit *LEdHeadLandingOffsetDist1;
    Edit *LEdHeadLandingOffsetDist3;

public:
    double up_dist;
    double up_speed;
    double dist_ready;
    double headn_land_exit_dist;
    double head_land_offset_dist_1;
    double head_land_offset_dist_3;
    double land_speed, land_speed_close, land_close_perc;
    bool headLanding = false;
    bool sysOnMAF = false;
    bool landUpward;
    QCheckBox *CB_HeadLanding;

    TOptionsForMotor();
};

class TOptionsForShuttle: public QWidget
{
    Q_OBJECT
    
public:
    static const int numMotors = 15;
    enum shuttleMotorRoles
    {
        OFF = -2,
        MFocus = 0,
        PiezoFocusZ = 1,
        FeedbackON = 2, FeedbackOFF = 3,
        MLanding = 4,
        M1Phys = 5, M2Phys = 6, M3Phys = 7,
        LandingToggle = 8,
        MStageX = 9,
        PiezoHeadX = 10, PiezoStageX = 11,
        PiezoStageY = 12, PiezoHeadY = 13,
        MStageY = 14,
        XPiezoM = 15, YPiezoM = 16, ZPiezoM = 17,
        NDFilter = 18, BeamExp, EdgeFilter, SlitMonochr, SlitPMT,
        MicroscTrin = 23, ObjXSlMonochr, ObjYSlMonochr, ObjXSlPMT, ObjYSlPMT,
        M1 = 101, M2, M3, M4, M5, M6, M7, M8, M9, M10,
        MHeadX = 151, MHeadY = 152,
        PiezoHeadZ = 250,
    };
    
public slots:
    void sl_update();
    void sl_save_to_file();
    void sl_load_from_file();
    void HideAdditionShuttleButtons(int hide);

private:
    bool eventFilter(QObject *obj, QEvent *event) override;
    void resizeEvent(QResizeEvent *event) override;
    void fillCBKeyRole(QComboBox* keyRole);
    QLabel *labBtnNum[numMotors];
    QVBoxLayout *mainLay;
    Edit *EPMinSpeed;
    Edit *EPMaxSpeed;
    QComboBox *CBKeyRole[numMotors];
    QWidget *grKeyWid;

private slots:
    void updateGrKeyHeight();

public:
    TOptionsForShuttle();

    QVBoxLayout **VBLMapRow;
    QGroupBox *GrBUp;
    QGroupBox *GrBMap;
    QLabel *shuttleStatus;
    double min_piezo_speed, max_piezo_speed;
    Edit *EKeyStep[numMotors];
    Edit *EKeySpeed[numMotors];
    QCheckBox *CKeyReverse[numMotors];
};
